using UnityEngine;


[ExecuteInEditMode]
public class GameManager : MonoBehaviour
{
	public static GameObject selectedObject;
	
//	private Vector3 lastCoord;
	private Vector3 selectedPos;
	private float selectedObjectDistanceFromCamera;
	
	
	void HandleObjectMovement(){
		if(Camera.main){
			if(selectedObject!=null){
				if(Input.GetAxis("Mouse ScrollWheel")!=0)
					selectedObjectDistanceFromCamera+=Input.GetAxis("Mouse ScrollWheel")*10;
				Vector3 currentCoord = Input.mousePosition;
				if(Screen.lockCursor){
					currentCoord = CameraMovement.oldMousePosition;
				}
				Vector3 objectPos = selectedObject.transform.position;//TransformPoint(selectedPos);
//				Vector3 objectPosOnScreen = Camera.main.WorldToScreenPoint(objectPos);
				currentCoord.z = selectedObjectDistanceFromCamera;
				Vector3 objectNextPos = Camera.main.ScreenToWorldPoint(currentCoord);
                //Vector3 movement = objectNextPos-objectPos;
                //movement*=movement.magnitude;
                //movement.x/=selectedObject.transform.lossyScale.x;
                //movement.y/=selectedObject.transform.lossyScale.y;
                //movement.z/=selectedObject.transform.lossyScale.z;
                //movement*=0.5f/Time.fixedDeltaTime;
				Debug.DrawLine(objectNextPos,objectPos);
				if(selectedObject.GetComponent("PortalableObject")){
					PortalableObject po = selectedObject.GetComponent("PortalableObject") as PortalableObject;
                    if(po!=null){
					    if(po.Other){
						    po.SetVelocity(0.5f*(objectNextPos-objectPos)/Time.fixedDeltaTime);
					    }
					    else{
						    selectedObject.rigidbody.velocity=0.5f*(objectNextPos-objectPos)/Time.fixedDeltaTime;	
					    }
                    }
				}
				else{
					selectedObject.rigidbody.velocity=0.5f*(objectNextPos-objectPos)/Time.fixedDeltaTime;
				}
				selectedObject.rigidbody.angularVelocity*=0.1f;
				//selectedObject.rigidbody.velocity = Vector3.zero;
				//selectedObject.rigidbody.AddForceAtPosition(movement,objectPos);
			}
//			lastCoord = Input.mousePosition;
		}
	}
	void HandleObjectSelection(){
		if(!Screen.lockCursor){
			if(Camera.main){
				Ray ray = Camera.main.ScreenPointToRay(Input.mousePosition);
				foreach(RaycastHit hitInfo in Physics.RaycastAll(ray,1000)){
					if(hitInfo.collider.rigidbody){
						if(Input.GetMouseButtonDown(0)){
							selectedObject = hitInfo.collider.gameObject;
							selectedPos = hitInfo.collider.gameObject.transform.InverseTransformPoint(hitInfo.point);
							Vector3 objectPos = selectedObject.transform.TransformPoint(selectedPos);
							Vector3 objectPosOnScreen = Camera.main.WorldToScreenPoint(objectPos);
							selectedObjectDistanceFromCamera = objectPosOnScreen.z;
							break;
						}
						//selectedObject = hitInfo.collider.gameObject;
						//while(selectedObject.transform.parent){
						//	selectedObject = selectedObject.transform.parent.gameObject;
						//}
						/*
						oldMat = selectedObject.renderer.material;
						Color oldColor;
						if(oldMat.HasProperty("_Color")){
							oldColor = oldMat.color;
						}
						else
							oldColor = new Color(1,1,1,1);
						
						selectionMat.color = oldColor;
						selectedObject.renderer.material = selectionMat;
						*/
					}
				}
			}
			if(!Input.GetMouseButton(0))
				selectedObject = null;
		}
	}
	// Update is called once per frame
    public void Update()
	{
		HandleObjectSelection();
		HandleObjectMovement();
		foreach(Camera c in FindObjectsOfType(typeof(Camera))){
			GameObject curObj = c.gameObject;
			if(!curObj.GetComponent("PortalableCamera")){
				curObj.AddComponent("PortalableCamera");
			}
		}
#if UNITY_EDITOR
        if (!Application.isEditor) return;
        //Debug.Log(UnityEditor.SceneView.lastActiveSceneView.camera);
        //foreach(Camera curCam in UnityEditor.SceneView.GetAllSceneCameras()){
        if(UnityEditor.SceneView.lastActiveSceneView){
            Camera activeCamera = UnityEditor.SceneView.lastActiveSceneView.camera;
            GameObject curObj = activeCamera.gameObject;
				
            if(!curObj.GetComponent("PortalableCamera")){
                curObj.AddComponent("PortalableCamera");
            }
            //else{
            ////	Destroy(curObj.GetComponent("PortalableCamera"));
            //}
            //PortalableCamera curCam = curObj.GetComponent("PortalableCamera") as PortalableCamera;
            //curCam.ManualUpdate();
        }
        //}
#endif
	}

    public void EditorUpdate()
    {
	}
}

