using UnityEngine;

[ExecuteInEditMode]
public class PortalableCamera : MonoBehaviour
{
	private Vector3 lastPosition = Vector3.zero;
#if UNITY_EDITOR
	bool IsEditor{get{return UnityEditor.SceneView.lastActiveSceneView&&UnityEditor.SceneView.lastActiveSceneView.camera==camera;}}
#else
//	bool isEditor = false;
#endif
	
	// Use this for initialization
    public void Start()
	{
		
	}
    public void OnPreRender()
    {
		//(GetComponent("Camera") as Camera).projectionMatrix = Camera.main.projectionMatrix;
	}
    public void OnPostRender()
    {
		
	}

    public void Update()
	{
#if UNITY_EDITOR
		if(UnityEditor.SceneView.lastActiveSceneView)
			if(UnityEditor.SceneView.lastActiveSceneView.camera!=camera&&!Application.isPlaying){
				return;
			}
#endif
		if(lastPosition==Vector3.zero){
			lastPosition = transform.position;
		}
        else
        {
#if UNITY_EDITOR
			bool portaled = false;
#endif
            Vector3 pos = transform.position;
            if (lastPosition != pos)
            {
                Vector3 posDif = pos - lastPosition;
				const float scale = 3.0f;
                foreach (Collider c in Physics.OverlapSphere(pos, Vector3.Magnitude(posDif) * scale))
                {
                    Portal portal = c.gameObject.GetComponent<Portal>();
                    if (!portal||!portal.enabled) continue;
                    if ((portal.IsFacing(lastPosition) && !portal.IsFacing(pos)))
                    {
                        Quaternion newRot = Quaternion.LookRotation(portal.PortalDir(transform.forward),
                                                                    portal.PortalDir(transform.up));
#if UNITY_EDITOR
                        if (IsEditor){
                            Vector3 newPivotPos =
                                portal.PortalVector(UnityEditor.SceneView.lastActiveSceneView.pivot);

                            UnityEditor.SceneView.lastActiveSceneView.pivot = newPivotPos;
                            UnityEditor.SceneView.lastActiveSceneView.rotation = newRot;
                            UnityEditor.SceneView.lastActiveSceneView.size =
                                portal.PortalScalar(UnityEditor.SceneView.lastActiveSceneView.size);
                        }
                        else{
                        //transform.position = newTransformPos;
//#else
#endif
                            Vector3 newTransformPos = portal.PortalVector(pos);
                            transform.position = newTransformPos;
                            transform.rotation = newRot;
#if UNITY_EDITOR
                        }
#endif
                        if (GetComponent<CameraMovement>())
                        {
                            GetComponent<CameraMovement>().cameraMoveSpeed *= portal.MyTarget.scale/portal.scale;
                            //(GetComponent("CameraMovement") as CameraMovement).cameraRotateSpeed*=p.myTarget.scale/p.scale;
                        }
#if UNITY_EDITOR
                        portaled = true;
#endif
                        break;
                    }
				}
#if UNITY_EDITOR
				if(IsEditor&&!portaled){
					Vector3 euler = transform.rotation.eulerAngles;
					while(euler.z>180)
						euler.z-=360;
					while(euler.z<-180)
						euler.z+=360;
					euler.z *= 0.9f;
					//Quaternion oldRot = transform.rotation;
					//oldRot.x *= 0.5f;

					Vector3 editorEuler = UnityEditor.SceneView.lastActiveSceneView.rotation.eulerAngles;
					while(editorEuler.z>180)
						editorEuler.z-=360;
					while(editorEuler.z<-180)
						editorEuler.z+=360;
					editorEuler.z *= 0.9f;
					//Quaternion oldEditorRot = UnityEditor.SceneView.lastActiveSceneView.rotation;
					//oldEditorRot.x *= 0.5f;
					UnityEditor.SceneView.lastActiveSceneView.rotation = Quaternion.Euler(editorEuler);

						//	Quaternion.Lerp(UnityEditor.SceneView.lastActiveSceneView.rotation)
					transform.rotation = Quaternion.Euler(euler);
				}
#endif
			}
            lastPosition = pos;	
		}
	}
	
}

